import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {Settle, SettleParam} from './model';

/**
 * 分页查询结算
 */
export async function pageSettle(params: SettleParam) {
  const res = await request.get<ApiResult<PageResult<Settle>>>(
    '/tower/tower-settle/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listSettle(params?: SettleParam) {
  const res = await request.get<ApiResult<Settle[]>>(
    '/tower/tower-settle',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getSettle(id: number) {
  const res = await request.get<ApiResult<Settle>>(
    '/tower/tower-settle/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addSettle(data: Settle) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateSettle(data: Settle) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchSettle(data: Settle[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-settle/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeSettle(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-settle/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchSettle(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-settle/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
